stages:
  - lint
  - test
  - build
  - deploy

flake8:
  image: "python:3.10"
  stage: lint
  script:
    - pip install flake8
    - flake8

pytest:
  image: "python:3.10"
  stage: test
  script:
    - pip install -r requirements.txt
    - pip install pytest pytest-cov
    - export FLASK_ENV=test
    - pytest --cov --cov-report term --cov-report xml:coverage.xml
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

build-docker-image:
  stage: build
  only:
    - master
  image:
    name: gitlab-registry.cern.ch/ci-tools/docker-image-builder
    entrypoint: [""]
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"

.deploy_template: &deploy_definition
  stage: deploy
  image: gitlab-registry.cern.ch/paas-tools/openshift-client:latest


deploy-qa:
  <<: *deploy_definition
  variables:
    APP_NAME: data-management-api
    NAMESPACE: caimira-data-service-qa
    OPENSHIFT_SERVER: https://api.paas.okd.cern.ch
  script:
    - oc tag --source=docker ${CI_REGISTRY_IMAGE}:latest ${APP_NAME}:latest --token ${QA_DEPLOY_TOKEN} --server=${OPENSHIFT_SERVER} -n ${NAMESPACE}
  only:
    - master

deploy-prod:
  <<: *deploy_definition
  variables:
    APP_NAME: data-management-api
    NAMESPACE: caimira-data-service
    OPENSHIFT_SERVER: https://api.paas.okd.cern.ch
  script:
    - oc tag --source=docker ${CI_REGISTRY_IMAGE}:latest ${APP_NAME}:latest --token ${DEPLOY_TOKEN} --server=${OPENSHIFT_SERVER} -n ${NAMESPACE}
  rules:
    - if: "$CI_COMMIT_TAG"
